<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;
use App\Http\Base\BaseModel;

class ApproverModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table="approver";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable="approver";

	/**
	* primary key from table remember eloquent doesnt support composite primary key
	*/
	protected $primaryKey = "id";
	/**
	* fillable property for eloquent attribute cast
	*/
	protected $fillable=[
		"id","roleId","formIdApprover", "date_updated"
	];
	/**
	* Creating raw object from table that, this purpose for making you easier for remembering all attribute
	*/


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
    */
	protected $aliasPaging = [
		"id" => "approver.id",
		"roleId" => "roleId.id",
		"formIdApprover" => "approver.formIdApprover",
	];

	/**
	* relation from ' . roles . ' by ' . roleId 
	* join roles on roles.id = approver.roleId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationRoleId($alias = "roleId")
	{
		$this->getQuery()->join("roles as $alias", "$alias.id", "=", "approver.roleId");
		return $this;
	}

}